/* idn_cmd.h */

/* File autogenerated by gengetopt version 2.18  */

#ifndef IDN_CMD_H
#define IDN_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION VERSION
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  const char *stringprep_help; /* Prepare string according to nameprep profile help description.  */
  const char *punycode_decode_help; /* Decode Punycode help description.  */
  const char *punycode_encode_help; /* Encode Punycode help description.  */
  const char *idna_to_ascii_help; /* Convert to ACE according to IDNA (default) help description.  */
  const char *idna_to_unicode_help; /* Convert from ACE according to IDNA help description.  */
  int allow_unassigned_flag;	/* Toggle IDNA AllowUnassigned flag (default=off).  */
  const char *allow_unassigned_help; /* Toggle IDNA AllowUnassigned flag help description.  */
  int usestd3asciirules_flag;	/* Toggle IDNA UseSTD3ASCIIRules flag (default=off).  */
  const char *usestd3asciirules_help; /* Toggle IDNA UseSTD3ASCIIRules flag help description.  */
  int tld_flag;	/* Check string for TLD specific rules\nOnly for --idna-to-ascii and --idna-to-unicode (default=on).  */
  const char *tld_help; /* Check string for TLD specific rules\nOnly for --idna-to-ascii and --idna-to-unicode help description.  */
  char * profile_arg;	/* Use specified stringprep profile instead\nValid stringprep profiles are `Nameprep', `iSCSI', `Nodeprep', `Resourceprep', `trace', and `SASLprep'..  */
  char * profile_orig;	/* Use specified stringprep profile instead\nValid stringprep profiles are `Nameprep', `iSCSI', `Nodeprep', `Resourceprep', `trace', and `SASLprep'. original value given at command line.  */
  const char *profile_help; /* Use specified stringprep profile instead\nValid stringprep profiles are `Nameprep', `iSCSI', `Nodeprep', `Resourceprep', `trace', and `SASLprep'. help description.  */
  int debug_flag;	/* Print debugging information (default=off).  */
  const char *debug_help; /* Print debugging information help description.  */
  int quiet_flag;	/* Silent operation (default=off).  */
  const char *quiet_help; /* Silent operation help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int stringprep_given ;	/* Whether stringprep was given.  */
  int punycode_decode_given ;	/* Whether punycode-decode was given.  */
  int punycode_encode_given ;	/* Whether punycode-encode was given.  */
  int idna_to_ascii_given ;	/* Whether idna-to-ascii was given.  */
  int idna_to_unicode_given ;	/* Whether idna-to-unicode was given.  */
  int allow_unassigned_given ;	/* Whether allow-unassigned was given.  */
  int usestd3asciirules_given ;	/* Whether usestd3asciirules was given.  */
  int tld_given ;	/* Whether tld was given.  */
  int profile_given ;	/* Whether profile was given.  */
  int debug_given ;	/* Whether debug was given.  */
  int quiet_given ;	/* Whether quiet was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* IDN_CMD_H */
